/*
 * Swagger Basket
 *
 * Корзина товаров
 *
 * The version of the OpenAPI document: 1.0.0
 *
 * Generated by: https://openapi-generator.tech
 */

using System.ComponentModel.DataAnnotations;
using BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Attributes;
using BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Models;
using Microsoft.AspNetCore.Mvc;
using Swashbuckle.AspNetCore.Annotations;

namespace BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Controllers;

/// <summary>
/// </summary>
[ApiController]
public abstract class DefaultApiController : ControllerBase
{
    /// <summary>
    ///     Добавить адрес доставки
    /// </summary>
    /// <remarks>Позволяет добавить адрес доставки</remarks>
    /// <param name="basketId">Идентификатор корзины</param>
    /// <param name="address">Адрес</param>
    /// <response code="200">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpPost]
    [Route("/api/v1/baskets/{basketId}/address/add")]
    [Consumes("application/json")]
    [ValidateModelState]
    [SwaggerOperation("AddAddress")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> AddAddress([FromRoute(Name = "basketId")] [Required] Guid basketId,
        [FromBody] Address address);

    /// <summary>
    ///     Добавить период доставки
    /// </summary>
    /// <remarks>Позволяет период доставки</remarks>
    /// <param name="basketId">Идентификатор корзины</param>
    /// <param name="body">Период доставки</param>
    /// <response code="200">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpPost]
    [Route("/api/v1/baskets/{basketId}/delivery-period/add")]
    [Consumes("application/json")]
    [ValidateModelState]
    [SwaggerOperation("AddDeliveryPeriod")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> AddDeliveryPeriod([FromRoute(Name = "basketId")] [Required] Guid basketId,
        [FromBody] string body);

    /// <summary>
    ///     Изменить позицию
    /// </summary>
    /// <remarks>Позволяет добавить/удалить/изменить позицию</remarks>
    /// <param name="basketId">Идентификатор корзины</param>
    /// <param name="item">Позиция</param>
    /// <response code="200">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpPost]
    [Route("/api/v1/baskets/{basketId}/items/change")]
    [Consumes("application/json")]
    [ValidateModelState]
    [SwaggerOperation("ChangeItems")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> ChangeItems([FromRoute(Name = "basketId")] [Required] Guid basketId,
        [FromBody] Item item);

    /// <summary>
    ///     Оформить корзину
    /// </summary>
    /// <remarks>Позволяет оформить корзину</remarks>
    /// <param name="basketId">Идентификатор корзины</param>
    /// <response code="200">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpPost]
    [Route("/api/v1/baskets/{basketId}/checkout")]
    [ValidateModelState]
    [SwaggerOperation("Checkout")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> Checkout([FromRoute(Name = "basketId")] [Required] Guid basketId);

    /// <summary>
    ///     Получить корзину
    /// </summary>
    /// <remarks>Позволяет получить корзину</remarks>
    /// <param name="basketId">Идентификатор корзины</param>
    /// <response code="200">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpGet]
    [Route("/api/v1/baskets/{basketId}")]
    [ValidateModelState]
    [SwaggerOperation("GetBasket")]
    [SwaggerResponse(200, type: typeof(Basket), description: "Успешный ответ")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> GetBasket([FromRoute(Name = "basketId")] [Required] Guid basketId);

    /// <summary>
    ///     Оформить покупку (метод для теста)
    /// </summary>
    /// <remarks>Позволяет оформить покупку с целью тестирования</remarks>
    /// <response code="201">Успешный ответ</response>
    /// <response code="0">Ошибка</response>
    [HttpPost]
    [Route("/api/v1/baskets/new/test-checkout")]
    [ValidateModelState]
    [SwaggerOperation("TestCheckout")]
    [SwaggerResponse(0, type: typeof(Error), description: "Ошибка")]
    public abstract Task<IActionResult> TestCheckout();
}